=== debian/changelog ===
r-cran-quickjsr (1.1.3-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 31 Jan 2024 21:52:59 +0100

r-cran-quickjsr (1.0.9-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jan 2024 08:36:39 +0100

r-cran-quickjsr (1.0.8-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sun, 26 Nov 2023 17:56:41 +0100

r-cran-quickjsr (1.0.7-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 17 Oct 2023 20:16:34 +0200

r-cran-quickjsr (1.0.6-1) unstable; urgency=medium

  * Initial release (closes: #1052457)

 -- Andreas Tille <tille@debian.org>  Fri, 22 Sep 2023 17:08:18 +0200
