=== debian/control ===
Source: r-cran-quickjsr
Section: gnu-r
Priority: optional
Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
Uploaders: Andreas Tille <tille@debian.org>
Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr
Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr.git
Homepage: https://cran.r-project.org/package=QuickJSR
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-r,
               r-base-dev,
               r-cran-jsonlite,
               r-cran-r6,
               r-cran-rcpp
Testsuite: autopkgtest-pkg-r

Package: r-cran-quickjsr
Architecture: any
Depends: ${R:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: ${R:Recommends}
Suggests: ${R:Suggests}
Description: GNU R Interface for the 'QuickJS' Lightweight 'JavaScript' Engine
 An 'R' interface to the 'QuickJS' portable 'JavaScript' engine.
 The engine is bundled entirely within the package, requiring no external system
 dependencies beyond a 'C' compiler.
