## r-cran-quickjsr 1.4.0

=== debian/changelog ===
r-cran-quickjsr (1.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * dh-update-R to update Build-Depends (routine-update)
  * Set upstream metadata fields: Repository.

 -- Charles Plessy <plessy@debian.org>  Thu, 10 Oct 2024 08:38:59 +0900
