=== debian/control ===
--- 
+++ 
@@ -6,14 +6,11 @@
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr.git
 Homepage: https://cran.r-project.org/package=QuickJSR
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-r,
-               r-base-dev,
-               r-cran-jsonlite,
-               r-cran-r6,
-               r-cran-rcpp
+               r-base-dev
 Testsuite: autopkgtest-pkg-r
 
 Package: r-cran-quickjsr
