## r-cran-quickjsr 1.5.1

=== debian/changelog ===
r-cran-quickjsr (1.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Charles Plessy <plessy@debian.org>  Fri, 24 Jan 2025 09:11:33 +0900
