## r-cran-quickjsr 1.6.0

=== DESCRIPTION ===
Package: QuickJSR
Title: Interface for the 'QuickJS' Lightweight 'JavaScript' Engine
Version: 1.6.0
Authors@R: c(
    person(c("Andrew", "R."), "Johnson", , "andrew.johnson@arjohnsonau.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-7000-8065")),
    person("QuickJS", "Authors", role = c("cph"),
           comment = "QuickJS sources and headers"),
    person("QuickJS-NG", "Authors", role = c("cph"),
           comment = "QuickJS-NG sources and headers")
  )
Description: An 'R' interface to the 'QuickJS' portable 'JavaScript'
    engine.  The engine and all 'R' to 'JavaScript' interoperability is bundled
    within the package, requiring no dependencies beyond a 'C' compiler.
License: MIT + file LICENSE
URL: https://github.com/andrjohns/QuickJSR,
        https://bellard.org/quickjs/
BugReports: https://github.com/andrjohns/QuickJSR/issues
Suggests: knitr, rmarkdown, tinytest
Encoding: UTF-8
Language: en-AU
NeedsCompilation: yes
RoxygenNote: 7.3.1
SystemRequirements: GNU make
VignetteBuilder: knitr
Packaged: 2025-02-26 15:48:10 UTC; Andrew
Author: Andrew R. Johnson [aut, cre] (<https://orcid.org/0000-0001-7000-8065>),
  QuickJS Authors [cph] (QuickJS sources and headers),
  QuickJS-NG Authors [cph] (QuickJS-NG sources and headers)
Maintainer: Andrew R. Johnson <andrew.johnson@arjohnsonau.com>
Repository: CRAN
Date/Publication: 2025-02-26 18:00:02 UTC
