=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-quickjsr.git
 Homepage: https://cran.r-project.org/package=QuickJSR
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-r,
