=== debian/watch ===
version=4
https://cloud.r-project.org/src/contrib/QuickJSR_([-\d.]*)\.tar\.gz
